function IthomeEditor(eleId, listener) {
    var that = this;
    window.um = UM.getEditor(eleId);
    domUtils = UM.dom.domUtils;
    if (listener) {
        um.ready(function () {
            rm.ready(function () {
                var hideButtons = ["code"];
                var hideHtmlBtn = true;

                var userInfo = rm.getUserInfoSync();
                if (userInfo && userInfo.success && userInfo.userInfo &&
                    (userInfo.userInfo.userid == 47
                        || userInfo.userInfo.userid == 1663439
                        || userInfo.userInfo.userid == 63163
                        || userInfo.userInfo.isc == "true"
                        || userInfo.userInfo.isn == "true"
                        || userInfo.userInfo.ise == "true"
                        || userInfo.userInfo.ism == "true"
                        || userInfo.userInfo.moderator > 0)) {
                    hideHtmlBtn = false;
                }

                if (hideHtmlBtn) {
                    hideButtons.push("html")
                }

                listener({
                    name: "_editor_ready", data: {
                        height: getDocHeight(),
                        colorsPreset: getColorPresetLib(),
                        hideButton: hideButtons
                    }
                })
                $(window).resize(function () {
                    listener({
                        name: "_editor_resize",
                        data: {
                            height: getDocHeight()
                        }
                    })
                });
                $('#' + eleId).on('input', function () {
                    refreshHintStatus();
                })
            })

        });
        um.addListener('blur', function () {
            listener({ name: "_editor_blur", data: {} })
        });
        um.addListener('focus', function () {
            listener({ name: "_editor_focus", data: {} })
        });
        um.addListener("selectionchange", function (e) {
            that.checkCurrentRangeStyle();
        });
        um.addListener("beforesetcontent", function (e) {
            console.log("beforesetcontent")
        })
        um.addListener("contentChange", function (e) {
            listener({
                name: "_editor_content_changed",
                data: { html: that.getHtml(), text: that.getText() }
            })
        });
    }
    // 撤销
    this.undo = function () {
        exe("undo");
    }

    this.canUndo = function(){
        return um.undoManger.hasUndo;
    }

    // 重做
    this.redo = function () {
        exe("redo");
    }

    this.canRedo = function(){
        return um.undoManger.hasRedo;
    }

    // 源码模式
    this.source = function () {
        this.setPlaceholder("")
        if (!um.queryCommandState('source')) {
            rm.toast({ data: "注意：请切换到正常模式再发布内容" })
        }
        this.checkCurrentRangeStyle()
        exe('source');
    }
    // 检查是否是源码模式
    this.isSourceMode = function () {
        return !!um.queryCommandState('source');
    }

    // 释放焦点
    this.blur = function () {
        if (that.isFocus()) {
            um.blur()
        }
    }
    // 获取焦点
    this.focus = function () {
        if (!that.isFocus()) {
            um.focus();
        }
    }
    // 查询焦点
    this.isFocus = function () {
        return um.isFocus();
    }
    // 滚动到顶部
    this.scrollToTop = function () {
        window.scroll({ top: 0, left: 0, behavior: 'auto' });
    }
    // 滚动到底部
    this.scrollToBottom = function () {
        window.scroll({ top: getDocHeight(), left: 0, behavior: 'auto' });
    }
    // TODO: 删除
    this.delete = function () {
        // var selection = window.getSelection();
        // selection.removeAllRanges();
        // var currentRange = um.selection.getRange()
        // var range = document.createRange();
        // range.setStart(currentRange.startContainer, currentRange.startOffset);
        // range.setEnd(currentRange.endContainer, currentRange.endOffset);
        // selection.addRange(range);
        // document.execCommand('delete', false, null);
    }
    // 插入图片，支持单个对象或对象列表
    this.insertImage = function (imgs) {
        refreshHintStatus(-1)
        if (Array.isArray(imgs)) {
            imgs.forEach(function (img) {
                exe('insertimage', { src: img.src, alt: img.alt });
            });
        } else {
            exe('insertimage', { src: imgs.src, alt: imgs.alt });
        }
    }
    // 插入表情
    this.insertEmotion = function (src, alt) {
        refreshHintStatus(-1);
        var imgTag = "<img class='ruanmei-emotion' src=" + src + " alt=" + alt + " />";
        that.inserHtml(imgTag);
    }
    // 当前位置插入HTML
    this.inserHtml = function (html) {
        refreshHintStatus(-1)
        exe('insertHtml', html);
        bindLinkCardClick();
    }
    // 设置整个HTML或在最后追加
    this.setHtml = function (html, isAppendTo) {
        refreshHintStatus(-1)
        um.setContent(html, isAppendTo);
        bindLinkCardClick();
    }
    // 获取HTML
    this.getHtml = function () {
        return um.getContent();
    }
    // 获取图片列表
    this.getImgs = function () {
        var root = UM.htmlparser(um.body.innerHTML, true);
        var imgs = [];
        $.each(root.getNodesByTagName('img'), function (i, node) {
            var src = node.getAttr("src");
            var className = node.getAttr("class");
            if (src && src.indexOf('http') === -1 && className !== "ruanmei-emotion") {
                imgs.push(src);
            }
        });
        return imgs;
    }
    // 获取纯文本（含段落格式等）
    this.getTextWithFormat = function () {
        return um.getPlainTxt();
    }
    // 获取纯文本，不含段落换行
    this.getText = function () {
        return um.getContentTxt();
    }
    // 是否有内容
    this.hasContent = function () {
        return um.getPlainTxt().length > 1 || um.hasContents();
    }
    // 获取当前选中文本
    this.getSelectedText = function () {
        return um.selection.getText();
    }
    // 获取当前选中HTML
    this.getSelectedHTML = function () {
        var doc = um.document;
        var win = um.window;
        var html = "";
        if (typeof win.getSelection != "undefined") {
            var sel = win.getSelection();
            if (sel.rangeCount) {
                var container = doc.createElement("div");
                for (var i = 0, len = sel.rangeCount; i < len; ++i) {
                    container.appendChild(sel.getRangeAt(i).cloneContents());
                }
                html = container.innerHTML;
            }
        } else if (typeof doc.selection != "undefined") {
            if (doc.selection.type == "Text") {
                html = doc.selection.createRange().htmlText;
            }
        }
        return html;
    }
    // 切换粗体
    this.switchBold = function () {
        exe('bold');
    }
    // 切换引用
    this.switchBlockquote = function () {
        refreshHintStatus(-1)
        exe('blockquote');
    }
    // 切换无序列表 
    this.switchUnorderedList = function () {
        refreshHintStatus(-1);
        exe('insertunorderedlist');
    }
    // 设置字体颜色
    this.setFontColor = function (color) {
        var colorName = getFontColorClass(color);
        console.log(colorName)
        if (colorName === "font-color-clear") {
            exe('forecolor', 'default');
        } else {
            var colorInfo = getColorPresetLib().find(function (item) {
                return item.day === color.toLowerCase()
                    || item.night === color.toLowerCase()
            });
            exe('forecolor', colorInfo ? colorInfo.day : "#d22222");
        }
    }
    // 清除颜色
    this.clearFontColor = function () {
        exe('forecolor', 'default');
    }
    // 插入段落，一般插入图片后在最后一张图后插入一个空段落
    this.insertparagraph = function () {
        refreshHintStatus(-1)
        exe('insertparagraph');
    }

    // 切换文字段落类型。p、h2、h3
    this.switchBlockType = function (type) {
        exe('paragraph', type);
    }

    // 插入代码
    this.insertCode = function (code) {
        refreshHintStatus(-1)
        exe('insertcode', "javascript");//语言无所谓，代码高亮插件自动识别语言
        exe('insertHtml', code);
    }
    // 插入链接，linkText为空时自动识别卡片
    this.insertLink = function (linkText, href, isModify) {
        console.log("插入链接", linkText, href, isModify)
        refreshHintStatus(-1)
        var that = this;
        var reslink = linkText;
        var reshref = href;
        if (!hrefStartWith(reshref, ["http", "ftp://", 'ed2k://', 'ithome://'])) {
            var preFix = (reshref.indexOf('.ithome.com') > -1
                || reshref.indexOf('.lapin365.com') > -1) ? 'https://' : 'http://';
            reshref = preFix + reshref;
        }

        // 这里判断是不是卡片，链接文字为空时，判断
        if (!isModify && isEmpty(linkText)) {
            utils.getLinkHtml(reshref, reslink, function (res) {
                if (res.linkType >= 0) {
                    that.unlink();//test
                    that.inserHtml("<p>" + res.cardHtml + "</p>");
                } else {
                    link(reslink, reshref);
                }
                // iOS端需要获取下焦点, 理论上不影响其他平台
                that.focus();
            })
        } else {
            link(isEmpty(reslink) ? reshref : reslink, reshref);
            that.focus();
        }
    }

    // 取消当前位置超链，文字保留
    this.unlink = function () {
        exe('unlink');
    }

    var __hintElement;
    // 设置内容为空时的占位提示文字
    this.setPlaceholder = function (text) {
        // 默认实现的placeholder不好用，自己实现一个
        var hintElement = document.getElementById("default-hint");
        if (!hintElement) {
            hintElement = document.createElement("div");
            hintElement.id = "default-hint";
            var editorTag = document.getElementById(eleId);
            var parentTag = editorTag.parentElement;
            hintElement.style.display = window.__hintElementHidden ? "none" : "block";
            parentTag.insertBefore(hintElement, editorTag);
        }
        __hintElement = hintElement;
        hintElement.innerHTML = text;
    }

    var handle;
    var __lastSendRangeStatusText;
    // 检测当前位置文字样式或标签类型等
    this.checkCurrentRangeStyle = function () {
        clearTimeout(handle);
        handle = setTimeout(function () {
            var status = { bold: false, unorderedList: false, blockquote: false };
            if (!um.queryCommandState('source')) {
                // 加粗
                status.bold = !!um.queryCommandState('bold');
                // 无序列表
                status.unorderedList = !!um.queryCommandState('insertunorderedlist');
                // 引用
                status.blockquote = !!um.queryCommandState('blockquote');
                // 字体颜色
                var fontcolor = um.queryCommandValue('forecolor');
                if (fontcolor) {
                    status.fontcolor = {
                        color: fontcolor.toLowerCase(),
                        name: getFontColorClass(fontcolor)
                    }
                }
                // 链接
                var range = um.selection.getRange();
                var orgNode = range.collapsed ? um.queryCommandValue('link') : um.selection.getStart();
                var orgLink = UM.dom.domUtils.findParentByTagName(orgNode, "a", true);
                if (orgLink) {
                    status.link = {
                        href: orgLink['href'],
                        text: orgLink['textContent']
                    }
                }
                // 段落类型
                status.paragraphType = um.queryCommandValue('paragraph');

            }

            var json = JSON.stringify(status);
            if (json !== __lastSendRangeStatusText) {
                listener && listener({ name: "_editor_range_status", data: status })
            }
            __lastSendRangeStatusText = json;
        }, 250);
    }

    // 设置编辑器内容最小高度，初始化时使用
    this.setMinHeight = function (height) {
        document.getElementById(eleId).style.minHeight = height + "px";
    }

    // 获取当前光标位置距离文档顶部的距离
    this.getCursorPosition = function () {
        var node50 = document.getSelection().anchorNode;
        if (!node50) { return -1; }
        node50 = (node50.nodeType == 3 ? node50.parentNode : node50);
        const rect50 = node50.getBoundingClientRect();
        return rect50.top + window.scrollY;
    }

    ///////////////////////
    ///  一些方法，非API  ///
    ///////////////////////
    // Methods
    function hrefStartWith(href, arr) {
        href = href.replace(/^\s+|\s+$/g, '');
        for (var i = 0, ai; ai = arr[i++];) {
            if (href.indexOf(ai) == 0) {
                return true;
            }
        }
        return false;
    }

    // 0: auto; 1: force display; -1: force hide
    function refreshHintStatus(mode) {
        if (__hintElement) {
            var currentShow = __hintElement.style.display !== "none";
            var needShow = !mode ? !that.hasContent() : (mode > 0);
            if (needShow && !currentShow) {
                __hintElement.style.display = "block";
                window.__hintElementHidden = false;
            } else if (!needShow && currentShow) {
                __hintElement.style.display = "none";
                window.__hintElementHidden = true;
            }
        } else {
            mode && (window.__hintElementHidden = mode < 0)
        }
    }

    function bindLinkCardClick() {
        $('.link-card').attr('contenteditable', 'false');
        $('.link-card').off("click").on("click", function () {
            event.preventDefault();
            var ele = $(this);
            listener && listener(
                {
                    name: "_editor_modify_link_card",
                    data: { url: ele.attr("href") }
                },
                function (res1) {
                    console.log("链接修改结果", res1)
                    if (res1.success && res1.result) {
                        utils && utils.getLinkHtml(res1.result.href, res1.result.text, function (res) {
                            var html = null;
                            console.log("卡片获取结果", res)
                            if (res.linkType >= -1) {
                                if (!isEmpty(res1.result.text) || res1.result.foreNormalLink) {
                                    html = res.normalHtml;
                                } else if (res.linkType >= 0) {
                                    html = res.cardHtml;
                                }
                            }

                            if (html && html.length > 0) {
                                ele[0].parentNode.insertAdjacentHTML('afterend', html);
                                bindLinkCardClick();
                            }
                            UM.dom.domUtils.remove(ele[0].parentNode);
                        })

                    }
                })
        })
    }

    function link(reslink, reshref) {
        var range = um.selection.getRange();
        var orgNode = range.collapsed ? um.queryCommandValue('link') : um.selection.getStart();
        var orgLink = UM.dom.domUtils.findParentByTagName(orgNode, "a", true);
        if (orgLink) {
            var orgText = orgLink['textContent'];
            var obj = {
                'href': reshref,
                'target': "_blank",
                'title': reslink,
                '_href': reshref
            };
            if (orgText && reslink != orgText) {
                orgLink['textContent'] = obj.textValue = reslink;
                range.selectNode(orgLink).select()
            }
            if (range.collapsed) {
                obj.textValue = reslink;
            }
            exe('link', UM.utils.clearEmptyAttrs(obj));
        } else {
            exe('link', { href: reshref, textValue: reslink, target: '_blank' });
        }
    }

    function exe(n, d) {
        um.execCommand(n, d);
    }

    function getDocHeight() {
        return document.getElementById(eleId).getBoundingClientRect().height;
    }

    function getFontColorClass(hex) {
        var color = getColorPresetLib().find(function (item) {
            return item.day.toLowerCase() === hex.toLowerCase()
                || item.night.toLowerCase() === hex.toLowerCase();
        })
        return !!color ? "font-color-" + color.name : "";
    }
    function isEmpty(str) {
        return typeof str == typeof undefined || str == null || str.length == 0;
    }
    function getColorPresetLib() {
        return [
            { "name": "clear", "day": "#333333", "night": "#999999" },
            { "name": "red", "day": "#d22222", "night": "#8d4444" },
            { "name": "yellow", "day": "#eca500", "night": "#795e1e" },
            { "name": "orange", "day": "#ff7e00", "night": "#764210" },
            { "name": "orangered", "day": "#fb4e01", "night": "#8a4a2d" },
            { "name": "purple", "day": "#9b0080", "night": "#844579" },
            { "name": "lyonsblue", "day": "#3e007b", "night": "#6d5486" },
            { "name": "blue", "day": "#0f3193", "night": "#485479" },
            { "name": "skyblue", "day": "#0091ea", "night": "#1d5678" },
            { "name": "darkcyan", "day": "#255965", "night": "#3f5a60" },
            { "name": "aqua", "day": "#00968b", "night": "#1f5954" },
            { "name": "darkgreen", "day": "#548b30", "night": "#4c603e" },
            { "name": "green", "day": "#379e28", "night": "#3f6739" }]
    }
}